package jp.co.opentone.servlet;

import java.io.FileInputStream;
import java.io.IOException;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;
import java.util.Collections;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.opentone.bean.KeyEntryInfo;
import jp.co.opentone.bean.KeyStoreInfo;
import jp.co.opentone.util.CertUtil;


/**
 * ReiɃ[hĂL[XgA\T[ubg
 * @author thatanaka
 */
public class ShowKeyStoreServlet extends javax.servlet.http.HttpServlet implements javax.servlet.Servlet {
	
	/** CȀؖGg̃GCAX */
	private static final String ALIAS_CA = "myca";
	/** T[o[ؖGg̃GCAX */
	private static final String ALIAS_SERVER = "myserver";
	/** L[XgAt@C̃pX(KvɉďCĂB) */
	private static final String KEYSTORE_PATH = ".keystore";
	/** L[XgÃpX[h(KvɉďCĂB) */
	private static final String KEYSTORE_PASSWORD = "changeit";
	
	/* (non-Java-doc)
	 * @see javax.servlet.http.HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		processRequest(request, response);
	}  	
	
	/* (non-Java-doc)
	 * @see javax.servlet.http.HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		processRequest(request, response);
	}
	
	/**
	 * L[XgAɃANZXăf[^x[X\B
	 */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    	
    	// L[XgA̎擾ƃ[h
    	KeyStore store = null;
    	try {
			store = KeyStore.getInstance("JKS", "SUN");
    		store.load(new FileInputStream(KEYSTORE_PATH), KEYSTORE_PASSWORD.toCharArray());
		} catch (KeyStoreException e) {
			throw new ServletException("Key store not found !!!", e);
		} catch (NoSuchProviderException e) {
			throw new ServletException("Provider not found !!!", e);
		} catch (NoSuchAlgorithmException e) {
			throw new ServletException("No such algorithm !!!", e);
		} catch (CertificateException e) {
			throw new ServletException("Certificate Exception !!!", e);
		}
    	
		// L[XgA̍\z
		KeyStoreInfo info = null;
		try {
			info = createKeyStoreInfo(store);
		} catch (KeyStoreException e) {
			throw new ServletException("KeyStore access error !!!", e);
		}
		if (info == null) {
			throw new ServletException("Failed to create keystore info.");
		}
	    // L[XgÃZbg
	    request.setAttribute("info", info);
	    
	    getServletContext().getRequestDispatcher("/showkeystore.jsp").forward(request, response);    	
    }
    
    /**
     * L[XgAb`AT[o[ANCAg̏ؖ擾B
     * @param store
     * @return
     * @throws KeyStoreException 
     */
	private KeyStoreInfo createKeyStoreInfo(KeyStore store) 
	throws KeyStoreException {
		KeyStoreInfo info = new KeyStoreInfo();
		info.setAliases(Collections.list(store.aliases()));
		info.addEntry(createEntryInfo(store, ALIAS_CA));
		info.addEntry(createEntryInfo(store, ALIAS_SERVER));
		return info;
	}
	/**
	 * L[XgAƕʖGg쐬B
	 * @param store
	 * @param alias
	 * @return
	 * @throws KeyStoreException
	 */
	private KeyEntryInfo createEntryInfo(KeyStore store, String alias) 
	throws KeyStoreException {
		KeyEntryInfo entry = new KeyEntryInfo();
		entry.setAlias(alias);
		entry.setCertInfo(CertUtil.createCertInfo(
				(X509Certificate)store.getCertificate(alias)));
		entry.setKey(store.isKeyEntry(alias));
		entry.setTrust(store.isCertificateEntry(alias));
		return entry;
	}
}